--------------------------------------
-- Namespaces
--------------------------------------
local _, core = ...
core.AltVaultStorage = {}

local AltVault = core.AltVault
local AltVaultStorage = core.AltVaultStorage

local STORAGE_TYPES = {
	"Bags",
	"Bank",
    "Guild Vault"
}

function AltVaultStorageFrame_OnLoad(self)
    AltVaultStorage:AltVaultStorageList(1)
end

function AltVaultStorageFrame_OnHide(self)
	CharacterJournal.storageType = 1
    CharacterJournal.searchText = nil
    AltVaultStorageFrameSearchBox:SetText("")
end

function AltVaultStorage_OnSearchTextChanged(self)
    CharacterJournal.searchText = self:GetText()
    AltVaultStorage:AltVaultStorageList(CharacterJournal.storageType)
    SearchBoxTemplate_OnTextChanged(self)
end

function AltVaultStorageTypeDropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, AltVaultStorageTypeDropDown_Initialize, "MENU");
end

function AltVaultStorageTypeDropDown_Initialize(self, level)
	local info = UIDropDownMenu_CreateInfo();
	for i = 1, #STORAGE_TYPES do
		info.text = STORAGE_TYPES[i];
		info.checked = i == CharacterJournal.storageType;
		info.func = function() AltVaultStorage:AltVaultStorageList(i); end;
		UIDropDownMenu_AddButton(info);
	end
end

function AltVaultStorage:AltVaultStorageList(filterID)
	CharacterJournal.storageType = filterID
    AltVaultStorageFrameStorageType:SetText(STORAGE_TYPES[filterID])
    AltVaultStorageFrameContentBags:Hide()
    AltVaultStorageFrameContentBank:Hide()
    AltVaultStorageFrameContentGuildVault:Hide()

    if filterID == 1 then -- Bags
        AltVaultStorageFrameContentBags:Show()
    elseif filterID == 2 then -- Bank
        AltVaultStorageFrameContentBank:Show()
    elseif filterID == 3 then -- Guild Vault
        AltVaultStorageFrameContentGuildVault:Show()
    end
end